/*
	Designed & modify by Linjianghua
	reserve all code of this file
*/

#include "c_lib.h"
#include "_tfd.h"
#include "infor.h"

#ifndef	_STDIO_H
#include <process.h>
#include <fcntl.h>
#include <dos.h>
#endif

#define _MSG_(n)	CMDNMB+n

/*  -------------------------------*/
static _Int ErrMsg,/* have no effect val flag */
	oln, nwln;
/*------------------------------*/

void FreeTD(TxtDat *conMsg,_Int Allclr)
{
_Int i;
if(conMsg->fileRec)free(conMsg->fileRec);
if(conMsg->invfile)free(conMsg->invfile);
if(conMsg->ReVar)free(conMsg->ReVar);
if(conMsg->org)free(conMsg->org);
if(conMsg->mmdat){
	for(i=0;i<conMsg->ndt;i++)free(conMsg->mmdat[i]);
	free(conMsg->mmdat);
}
if(Allclr)free(conMsg);
else memset(conMsg,0,sizeof(TxtDat));
}

static void DatCtrlApp(DatCtrl *ctrl,_Int addcn)/* realloc org,nw */
{
if(ctrl->toluse>=ctrl->tolmem){
char **dat1, **dat2;
_Int t;
ctrl->tolmem += addcn;
dat1=(char **)malloc(ctrl->tolmem*8);
dat2=dat1+ctrl->tolmem;
if(ctrl->toluse>0){
    for(t=0;t<ctrl->toluse;t++)
	{ dat1[t]=ctrl->dat1[t]; dat2[t]=ctrl->dat2[t];	}
    free(ctrl->dat1);
	}
 ctrl->dat1=dat1;	ctrl->dat2=dat2;
 }
}

static void AddMsg(char **dat,char *add_)
{
un_Int vln, dln;
char *vp;
vln= *dat? strlen(*dat):0;
dln=vln+strlen(add_)+8; /* in fact, alloc mem at least:len+1 every time. */
vp=(char *)malloc(dln);
if(*dat){
	scopy(vp,*dat);
	vp[vln++]='\r';	vp[vln]='\n';
	scopy(vp+vln+1,add_);
	free(*dat);
	}
else scopy(vp,add_);
*dat=vp;
}

bool IsSetting(char *txt,char *freldnam,_Int *Val)
{/* [ Mode set = 1 ]   0 is normal, otherwise is reset */
char *pt;
_Int len=fmtVal(txt);
bool fg=false;
if(len==0)return true;  /* is the mode,so skip */

if( *txt!='[' || txt[len-1]!=']' )return false; /* is not mode */

/* ValSet=0; have done */
txt[len-1]=0;	txt++;
pt=strchr(txt,'=');
if(pt){
	*pt=0;	fmtVal(txt);
	if(stricmp(txt,freldnam)==0){
		fmtVal(++pt);
		*Val=atoi(pt);
		fg=true;
	}
}
return fg;
}

static _Int VerifyDat(TxtDat *conMsg,char *pt,char CH,_Int msg,bool *IsRem)
/* i>=0 the dat is effect,ǿȡ(еλ);0 no effect  */
{
char *pi, **Org, **Nw;
_Int t,cur,i,tn=conMsg->toluse;
DatCtrlApp((DatCtrl *)&conMsg->toluse,32);
if( CH>125 )goto skp;
if(IsRemChs(pt,IsRem,CH)||
  IsSetting(pt,"Mode set",&conMsg->ValSet)||
  (pi=strchr(pt,'='))==NULL)return -1;
*pi++=0;
if((oln=fmtVal(pt))==0||(nwln=fmtVal(pi))==0)return -1;
Org=conMsg->org;
Nw=conMsg->nw;
if(conMsg->ValSet){	Org[tn]=pi;	Nw[tn]=pt;	}
else { Org[tn]=pt;	Nw[tn]=pi; }

skp:	cur=tn;
for(t=0;t<tn;t++){/* ǷѼص*/
 if(memstr(Org[cur],0,Org[t],0,1|(msg&2))){
   if(msg_memstr){
	if(stricmp(Nw[t],Nw[cur])==0)return -1; /*  2 both equ */
	if((msg&4)==0){ /* can't set mult-val ظֵ */
		AddMsg(&conMsg->ReVar,Org[cur]);
		conMsg->cnReV++;	ErrMsg=true;
		return -1;
			}
	else break;
	  }
  else {/* only compare first ʵֻȽһΣһʵ */
	pi=Org[cur];	pt=Nw[cur];
	for(i=tn;i>t;i--){ Org[i]=Org[i-1];  Nw[i]=Nw[i-1];	}
	Org[t]=pi;		Nw[t]=pt;
	cur=t;/* adjust Ƚʱֵ(pos) */
	break;
	 }
  }
}/* is loaded? */
conMsg->toluse++;
return cur;
}

static char **ReAppDat(char **dat,unsigned _Int *m,unsigned _Int n)
{/* *m is dat's count  */
if(*m<=n){
char **tmp;
_Int a,cn;
*m += 8; cn=*m;
tmp=(char **)malloc( cn * 4 );
for(a=0; a < cn ; a++)tmp[a]=a<n? dat[a]:NULL;
if( n > 0 )free(*dat);
return tmp;
	}
else return dat;
}

static char **CalcFiles(TxtDat *conMsg,char *inpt,_Int *cn)
{/* use setagrv replace */
char *pt, **fname, *hd;
int n=10;
unsigned _Int fn=10, tol=0, t;
FmtInput(inpt, &n, ";, ", 32);
fname=(char **)malloc(40);
memset(fname,0,40);
for(hd=inpt,pt=inpt;*pt;pt++){
  if(*pt==32||pt[1]==0&&fname[tol]!=pt){
	if(*pt==32)*pt=0;
	fname[tol]=hd;  hd=pt+1;
	for(t=0;t<tol;t++)if(stricmp(fname[t],fname[tol])==0)continue;
	if(strstr(conMsg->fileRec,fname[tol])||strstr(conMsg->invfile,fname[tol]))continue;
	fname=ReAppDat(fname,&fn,++tol);
	}
}
*cn=tol;
return fname;
}

unsigned _Int MakeTD(TxtDat *conMsg,char *buf,_Int msg)/* return data's count */
{/* buf must heap,because it would be free */
unsigned _Int rt=0;
if(buf){
unsigned _Int i, len=strlen(buf)+1, n=conMsg->toluse, datlen=0;
char chr, *pt=buf;
bool IsRem=false;
conMsg->ValSet=0;
/* above is init some members val of class */
for (i=0; i<len; i++){
  chr = buf[i];
  if(strchr("\r\n,;",chr)){
	 buf[i]=0;
	 if(VerifyDat(conMsg,pt,chr,msg,&IsRem)>-1)datlen += oln+nwln+2;
	 if(buf[i+1]==10||buf[i+1]==13/* unix */){ pt=buf+i+2; i++; }
	 else	pt=buf+i+1;
	  }
   }

rt=conMsg->toluse-n;
if(rt){
  conMsg->mmdat=ReAppDat(conMsg->mmdat, &conMsg->mdt, conMsg->ndt);
  if(datlen+128 < len){  /*====compacted ==========*/
    char **Org=conMsg->org, **Nw=conMsg->nw;
    pt = (char *)malloc(datlen + 4);
    conMsg->mmdat[conMsg->ndt] = pt;
    while(n<conMsg->toluse){
	scopy(pt, Org[n]);
	Org[n] = pt;
	pt += strlen(pt) + 1;
	scopy(pt, Nw[n]);
	Nw[ n++ ] = pt;
	pt += strlen(pt) + 1;
	}
    free(buf);
   }/*====compacted ==========*/
  else conMsg->mmdat[conMsg->ndt] = buf;
conMsg->ndt++;
}
else free(buf);
/*ReCmpbk(rt);*/
}
return rt;
}

/* Use file msg
0 pop msg for show no effect loaded data.
1 CASE source
2 bit set 0, no mult-var set,
3 bit set 1, show errmsg
above is bit pos , default is 1+0+4
*/
void CreatTD(TxtDat *tfd,char *fnames,_Int msg)
{
char **flnm, *buf;
_Int j, cnOrg, cnfl;
unsigned int len;
if(fnames==NULL||fnames[0]==0){
	ManuInfo(_MSG_(0),true); return;
	}

flnm=CalcFiles(tfd,fnames,&cnfl);
if( (msg&1) && cnfl==0){
	free(flnm); 
	ManuInfo(_MSG_(1),true);
	return;
	}
cnOrg=tfd->cnRec;	ErrMsg=false;
/*-------------processe file----------------*/

for(j=0;j<cnfl;j++)if((buf=ReadFile(flnm[j],&len,true))!=NULL){
   if(MakeTD(tfd,buf,msg)>0){  /* return add cn */
	AddMsg(&tfd->fileRec,flnm[j]);
	tfd->cnRec++;
	}
   else AddMsg(&tfd->invfile,flnm[j]); /* set dat=0 */
}
/* ----processe file end----------- */
free(flnm);
if(tfd->cnRec==cnOrg&&/* msg:some use no need this warn */
   (msg&1))ManuInfo(_MSG_(2),true);

if(ErrMsg && (msg&4)==0 && (msg&8) && tfd->ReVar)popMsg(tfd->ReVar,"Reload",0);
}
