/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Copyright Linjianghua(Xempo)
  reserve all rights of this file
*/

#include "dire.h"
#include "normlib.h"
#include "filecon.h"

static int fix_msg;

int NumbsCmprs(RunTimLib *lib,DIRE *dir,BYTE *Stat)
{
 BYTE i, cnt_unit, clen, *statcmp;
 DirShadow *pdp;
 un_Int ctrl;

 _Long numb; /* for Zero type */
 int n, baseUnitLen, pos;
 MAU *send;
 bool zero, mode;
 if(dir){
  if(dst_dir==NULL){
  char *dirnam=(char *)ReGetDir(dir,NULL,1);
  if(dirnam){
    dst_dir=DirOpen(LibCmpr,NULL,dirnam);
    free(dirnam);
    }
   }
  }
  else goto skp;
  if(dst_dir){
    skp:pdp=GetDirShadow(dir,lib);
	cnt_unit=pdp->num_stats_block;
	ctrl=pdp->Format;
	n=pdp->_DAU;
	zero=isZero(ctrl);
	clen=pdp->n_statLen;
	send=MAUalloc(n);
	baseUnitLen=zero? statNumPos : 12;
	for(i=0; i<cnt_unit; i++,Stat+=clen){
	  if(zero)numb=pdp->_numb_++; /* 2 part, fast little */
	  if(*Stat==1 ){
		if(!zero)numb=*(_Long *)(Stat+statNumPos); /* faster */
		ReadStat(lib,dir,Stat,send,n);
		statcmp=StatSeek(LibCmpr,dst_dir,numb,NULL/*send*/,NUMB_WRITE);/* must set statpos, so call it */
		memcpy(statcmp,Stat, baseUnitLen);
		WriteStat(LibCmpr,dst_dir,statcmp,send,n);
		}
    /* because don't break copys, so ignore err */
	}
	FreeMAU(send,n); free(send);
/*	if(dir1)DirClose(LibCmpr,dir1);*/
  }
 return 1;
}

static _Int ReFixLen(_Int cnt,_Int use)
{
if(use<30){
	if(cnt<use)cnt=use;
	else if(cnt>8&&use<9)cnt=8;
	}
else if(use>30&&use<80)cnt=use/2;
	if(use>80)cnt=32;
return cnt;
}

void SetDirPara(DirShadow *pdp, un_Int *lst)
{
   *lst=pdp->Format;
   lst[1]=fix_msg? ReFixLen(pdp->num_stats_block,pdp->selfnumb):pdp->num_stats_block;
   lst[2]=fix_msg? ReFixLen(pdp->dir_stats_block,pdp->selfdir):pdp->dir_stats_block;
   lst[3]=pdp->_DAU;
}

int DirsCmprs(RunTimLib *lib,DIRE *pcdir,DIRE *dir)
{
char *dirnam=(char *)ReGetDir(dir,NULL,1);
 if(dirnam){
   un_Int lst[4];
   SetDirPara(getshadow(dir),lst);
   if(dst_dir)DirClose(LibCmpr,dst_dir);
   pcdir=DirCreat(LibCmpr,NULL,dirnam,lst);
   free(dirnam);
   if(pcdir)dst_dir=pcdir;
   else dst_dir=NULL;
 }
 return 1;
}

static const char compfile[]="rtl~cmpr.1_&";
RunTimLib *Compress(RunTimLib *send,const char *filenam,const char *extpara,int msg)
{/* msg >=32 set reopen */
  int rt, flg=0, b_cnt;
  un_Int lst[4];
  _Long diradr;
  char *ptr, *pt;
  if(filenam==NULL){ flg=1;
	filenam=compfile;
	ptr=(char *)separChr(send->fname);
	if(ptr){  *ptr=0;
		filenam=catstr(send->fname,filenam,ROOT_CH);
		flg=2;	*ptr=ROOT_CH;
		}
	}
  fix_msg=stricmp(extpara,"fit")==0;
  SetDirPara(getshadow(send),lst);
  LibCmpr=RTLcreat(filenam,lst);
  if(LibCmpr==NULL){ ManuInfo(idxdscpt,1); return send; }
  if(msg&256)printf("  Compress . . .");
  dst_dir=NULL;
  rt=DirFullBrow(send,16391,NumbsCmprs,NULL,DirsCmprs);
  if(dst_dir)DirClose(LibCmpr,dst_dir);
  if(send->CurDir){
	pt=(char *)ReGetDir(send->CurDir,NULL,1);
	LibCmpr->CurDir=DirOpen(LibCmpr,NULL,pt);
	if(pt)free(pt);
	b_cnt=LibCmpr->mdf; diradr=LibCmpr->CurDir->pOwn;
	}
  else { LibCmpr->mdf=64;  b_cnt=0; diradr=39; }
  LibCmpr->DefaultDir=LibCmpr->mdf&64 ? 39:LibCmpr->CurDir->pOwn;
  RTLclose(LibCmpr,NULL);
  LibCmpr=NULL;/* this is flags, must clear it */
  if(flg&&rt){
	ptr=strdup(send->fname);
	rt=send->fd;
	RTLdestroy(send);
	remove(ptr);
	rename(filenam,ptr);
	send=msg&255? RTLinstance(ptr,msg):NULL;
	workspace[send->fd]=NULL;
	workspace[rt]=send;
	send->fd=rt;
	if((b_cnt&64)&&diradr>39){
	  send->CurDir=DirRead(send,DIRalloc(),NULL,diradr);/* default dir */
	  send->mdf|=65;
	}
	free(ptr);
	}
  if(flg==2)free((void *)filenam);
  return send;
}

#include "create.c"
#include "copys.c"
