/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010
  Copyright Linjianghua(Xempo)
  reserve all rights of this file
*/

#include "stat.h"
#include "jxswitch.h"
#include "infor.h"
#include "rtlcom.h"
#include "numbio.h"

DIRE *dst_dir; /* extern */
static DIRE *srcdir;
static RunTimLib *dstlib;
int vbs;

int getspace(char *extpara,int *s,int *d)
{
if(extpara==NULL||*extpara==0)return 0;
else {
int i, val, len=extParaLen(extpara);
*s=-1; *d=-1;
for(i=0;i<len;i++)
  if(extpara[i]=='.'||i==0){
	if(extpara[i]=='.')i++;
	if(extpara[i]>47&&extpara[i]<58){
	    val=atoi(extpara+i);
	    if(*s>-1)*d=val;
	    else *s=val;
	}
	}
 return 1;
   }
}

int SelSpace(int sel)
{
RunTimLib *lib1=NULL;
  if(sel>LASTSPACE||sel<0)goto nullspace;
  if(sel>0){
	lib1=workspace[sel];
	if(lib1==NULL||lib1->fpt==NULL){ 
		nullspace: ManuInfo(48,1); 
		return -1;
		}
	}
  else if(sel==0){ ManuInfo(50,1); return -1; }
return sel;
}

bool SetMultSpac(RunTimLib **s_lib, RunTimLib **d_lib, char *extpara)
{
int s,d;
if(getspace(extpara,&s,&d)){
  if((s=SelSpace(s))>0)*s_lib=workspace[s];
  else return false;
  if((d=SelSpace(d))>0)*d_lib=workspace[d];
  else return false;
}
return true;
}

int _copy(RunTimLib *lib,DIRE *s_dir,RunTimLib *d_lib,DIRE *d_dir,_Long srcnmb,_Long dstnmb,BYTE *srcStat)
{
char *spt, *dpt;
MAU *Sends;
DirShadow *pdp=GetDirShadow(s_dir,lib),
*dstpdp=GetDirShadow(d_dir,d_lib);
BYTE *stat=StatSeek(d_lib,d_dir,dstnmb,NULL,NUMB_READ);
_Int n=pdp->_DAU;
int rt=0;
_Long adr=-1;/* none type dau address is 0, so let it -1 */
if(stat){/*  specied data of dstnmb denied  */
	adr=*(_Long *)StatDAU(dstpdp,stat,0); free(stat);
}
Sends=MAUalloc(n);
if(srcStat){ stat=srcStat; ReadStat(lib,s_dir,srcStat,Sends,n); }
else stat=NumbRead(lib,s_dir,srcnmb,Sends,n, 0);

if(stat){
     if(adr==*(_Long *)StatDAU(pdp,stat,0))DefaultManu(I_SelfCpy);
     else {
	  if((rt=NumbPut(d_lib,d_dir,dstnmb,Sends,n,0))!=0 && vbs==0 ){
	    spt=(char *)ReGetDir(s_dir,NULL,1);
	    dpt=(char *)ReGetDir(d_dir,NULL,1);
	    printf("%s\\%ld ==> %s\\%d\n",spt? spt:SPC,srcnmb,dpt?dpt:SPC,dstnmb);
	    if(spt)free(spt);
	    if(dpt)free(dpt);
	  }
	}
 if(stat!=srcStat)free(stat);
 FreeMAU(Sends,n);
 }
else reportBug();
free(Sends);
return rt;
}

void NumbCopy(RunTimLib *curlib,char **pm,char *extpara)
{
  _Long srcnmb, dstnmb;
  int msgNo;
  RunTimLib *s_lib=curlib, *d_lib=curlib;
  DIRE *d_dir, *s_dir;
  char *dstpth, *srcpth=PathFixNumb(*pm,&srcnmb);
  if(numNone){ printf(" Source: %s  ", *pm);
	ManuInfo(42,1);	UsageMsg(8041);
	return;
	}
  if(SetMultSpac(&s_lib,&d_lib,extpara)==false)return;
  if( d_lib==NULL || s_lib==NULL){ ManuInfo(I_NoBuff,1); return; }
  s_dir=DirOpen(s_lib,s_lib->CurDir,srcpth);
  msgNo=idxdscpt;
  if(msgNo>0x7ffd){
    dstnmb=srcnmb; OverW=0;
    dstpth=PathFixNumb(pm[1],&dstnmb);
    d_dir=DirOpen(d_lib,d_lib->CurDir,dstpth);
    msgNo=idxdscpt;
    if(msgNo>0x7ffd){
/*	BrowCnt=0; why old=-1 ? */
/*	Sends=MAUalloc(Cnt_DAU((GetDirShadow(s_dir,s_lib))->Format));*/
	_copy(s_lib,s_dir,d_lib/* wait */,d_dir,srcnmb,dstnmb,NULL);
/*	free(Sends);*/
	if(d_dir!=d_lib->CurDir)DirClose(d_lib,d_dir);
    }
    else printf(pm[1]);
    if(s_dir&&s_dir!=s_lib->CurDir)free(s_dir);
  }
  else printf(*pm);
  if(msgNo<0x7ffd){
	DefaultManu(/*I_PthInv*/msgNo);
	UsageMsg(8041);
	}
}

int _copyNumbs(RunTimLib *lib,DIRE *dir,BYTE *dsb)
{
  DIRE *ddir=dst_dir;
  if(!(dir&&ddir&&dir->pOwn==ddir->pOwn)){
  char *dirnam=NULL, *pnam=(char *)SPC;
     if(dir&&dir->pOwn!=srcdir->pOwn){/* use 1st-div-dir... */
	dirnam=(char *)ReGetDir(dir,srcdir,1);
	pnam=srcdir? dirnam:dirnam+1;
	if(dirnam)ddir=DirOpen(dstlib,dst_dir,pnam);
	if(idxdscpt<0x7ffd){ ddir=dst_dir; idxdscpt=0x7fff; }
      }
  if(idxdscpt>0x7ffd){
      DirShadow *srcpdp=GetDirShadow(dir,lib);
      un_Int style=srcpdp->Format;
      BYTE *unit=dsb, i;
      _Long numb;
      bool zero=isZero(style);
/*      Sends=MAUalloc(n);*/
	if(zero)numb=srcpdp->_numb_;
	for(i=0;OverW!=27&&i<srcpdp->num_stats_block;i++,unit+=srcpdp->n_statLen){
		if(*unit==1){
			if(!zero)numb=*(_Long *)(unit+statNumPos);
			if(_copy(lib,dir,dstlib,ddir,numb,numb,unit))/* copy can change pdp->_numb_ */
	  		BrowCnt++;
 /* because don't break copys, so ignore err, don't OPM like compress */
		}
	if(zero)numb++;
	}
/*    free(Sends);*/
    srcpdp->_numb_=numb;
    if(dirnam)free(dirnam);
    if(ddir!=dst_dir&&ddir!=dstlib->CurDir)DirClose(dstlib,ddir);
/* every workspace->CurDir must exist, CurLib only is one of workspace */
   }
}
  return (OverW!=27 ? 1:0);
}

int _copyDirs(RunTimLib *lib,DIRE *pcdir,DIRE *dir)
{
if(OverW==27)return false;
if(lib!=dstlib||dir->pOwn!=dst_dir->pOwn){ /* defence self-copy loop */
  char *dirnam=(char *)ReGetDir(dir,srcdir,1);
  if(dirnam){
    un_Int lst[4];
    *lst=dir->Format;		lst[1]=dir->num_stats_block;
    lst[2]=dir->dir_stats_block; lst[3]=dir->_DAU;
    pcdir=DirCreat(dstlib,dst_dir,srcdir? dirnam:dirnam+1,lst);
    free(dirnam);
    if(pcdir!=dstlib->CurDir)DirClose(dstlib,pcdir);
  }
}
 return 1;
}

const char *plst[2]={ "--reply", "--noverbose" };/* ==> 1024<<0, 1024<<1, 1024<<2... */
void DirCopy(RunTimLib *curlib, int n,char **pm,char *extpara, int nCom)
{
  RunTimLib *s_lib=curlib, *d_lib=curlib;
  DIRE *ddst, *dir;
  DirShadow *pdp;
  int msg, errNum;
  if(SetMultSpac(&s_lib, &d_lib, extpara)==false)return;
  if(d_lib==NULL||s_lib==NULL){ ManuInfo(I_NoBuff,1); return; }
/*  if(d_lib->fpt->bsize<513)setvbuf(d_lib->fpt,malloc(8192),_IOFBF,8192);*/ 
/* only set dst-buffs */
  if(nCom!=8043){ msg=7; /*4|2|1*/  dir=DirOpen(s_lib,s_lib->CurDir,*pm); }
  else dir=JxDirPara(s_lib, n, pm, plst, &msg, nCom);
  OverW=msg&1024? 'a':0;
  vbs=msg&2048;
  errNum=idxdscpt;
  if(errNum>0x7ffd){
     un_Int lst[4];
     if(dir){
	pdp=getshadow(dir);
	*lst=pdp->Format;
	}
      else {
	pdp=getshadow(s_lib);
	*lst=pdp->Format&0xfffe;
	}
     lst[1]=pdp->num_stats_block;
     lst[2]=pdp->dir_stats_block;
     lst[3]=pdp->_DAU;
    ddst=DirOpen(d_lib,d_lib->CurDir,pm[1]);
    if(idxdscpt>0x7ffd){
      DIRE *_dir;
      if(ddst&&d_lib==s_lib&&ddst->pOwn==dir->pOwn){ DefaultManu(I_SelfCpy); return; }
      if(nCom!=8043){
	char *ptr=(char *)separChr(*pm);
	_dir=DirCreat(d_lib,ddst,ptr?ptr+1:*pm,lst);
	if(ddst!=d_lib->CurDir)DirClose(d_lib,ddst);
	ddst=_dir;
	}
    }
    else ddst=DirCreat(d_lib,d_lib->CurDir,pm[1],lst);
    errNum=idxdscpt;
    if(errNum<0x7ffd)printf(pm[1]); /* here can't ignore */
    else {
      srcdir=dir;  dst_dir=ddst; /* dir->_numb_=0;*/
	dstlib=d_lib; /*CurLib=curlib; above 3 var is extern */
      BrowCnt=0;	
      if( (msg&3)==0)msg=1;
      DirFullBrow(s_lib,msg,_copyNumbs,dir,_copyDirs);
      printf("Total copy : %lu\n",BrowCnt);
      if(ddst!=d_lib->CurDir)DirClose(d_lib,ddst);
    }
    if(dir&&dir!=s_lib->CurDir)free(dir);
  }
  else printf(*pm);
  if(errNum<0x7ffd){
	DefaultManu(errNum);
	UsageMsg(nCom);
	}
}
