/*
	Write & edit Linjianghua(xempo) 2005-06,2008-2011
	Copyright (xempo)
	reserve all rights of this file
*/

#include "dire.h"

#ifdef _STDIO_H
const char rootchs[]="/";
#else
#include <dos.h>
const char rootchs[]="\\";
#endif

void dSetChgflg(RunTimLib *lib,DIRE *cdir, int step, int dirflg, int sz)
{
DirShadow *pdp=GetDirShadow(cdir,lib);
  pdp->selfdir+=step; pdp->mdf|=dirflg;
  lib->tolDir+=step; lib->mdf|=1;
  if(cdir)cdir->sz+=sz*step;
}

void ShadowSet(DirShadow *pdp,const un_Int *pms)
{
    pdp->Format=*pms;
    pdp->num_stats_block=pms[1];
    pdp->dir_stats_block=pms[2];
    pdp->_DAU = pms[3] ? (pms[3]>7200 ? 7200 : pms[3] ) : 1;
    pdp->n_statLen=GetLenght(pdp);
    pdp->mdf=1;
}

DIRE *DirCreat(RunTimLib *lib,DIRE *Dir0,char *pth,const un_Int *pms)
{
DIRE *cdir=NULL, *dir=NULL;
char *dirnam;
if(pth==NULL||*pth==0)idxdscpt=I_PthInv;
else {
	cdir=DirFixNam(lib,Dir0,pth,&dirnam);
	NameVerify(dirnam);
 }

if(idxdscpt>0x7ffd){
    DirStat *du=DirSeek(lib,cdir,dirnam,DIRE_WRITE);
    if(idxdscpt>0x7ffd){
       dir=DIRalloc();
       memcpy(du->name,dirnam,Dirnamelen);
       if(cdir)dir->ptr_dir0=cdir->pOwn;

       ShadowSet(getshadow(dir),pms);

       du->Flags=1;
       du->savelen=rtlsze;
       dSetChgflg(lib,cdir,1,1,du->savelen);
       if(lib->statpos==0)
	StatLnkWord(lib,cdir,NULL,(cdir? cdir->dir_stats_block:lib->dir_stats_block) * d_statLen+4);

       if(du->pDir==0)du->pDir=lib->fsz;

       dir->OwnStat=lib->statpos;

       lib->fsz+=du->savelen; lib->usesize+=du->savelen;
       memcpy(dir,du,d_statLen);
       dkwrite(lib,dir->OwnStat,du,d_statLen);
     } /* creat sucesse */
}
else if(idxdscpt==I_NoDir)idxdscpt=I_PthInv;
if( cdir!=lib->CurDir && cdir!=Dir0 )DirClose(lib,cdir);
return dir;
}

RunTimLib *RTLcreat(const char *fnm, const un_Int *pms)
{
FILE *pff;
if((pff=fopen(fnm,"wb+"))!=NULL){
    RunTimLib *lib=RTLalloc();
    idxdscpt=0x7fff;
    lib->fpt=pff;
    memcpy(lib->fsfmt,FileFmt+libtaglen,FS_FMT-1);
    ShadowSet(getshadow(lib),pms);
    lib->sys_num_stats_block=5;

    lib->CmprSiz=8; /* k */
    lib->CmprPer=30;
    fwrite(FileFmt,sybchrlen,1,pff);
    lib->fsz=sybchrlen + ctrlsize;
    lib->usesize+=lib->fsz;
/*----------------------------------------------------*/
#ifdef	_STDIO_H
    lib->fname=realpath(fnm, NULL);
#else
    lib->fname=fullname(fnm);
    lib->comlst=(ComLst *)zalloc(sizeof(ComLst));
#endif
    return lib;
}
idxdscpt=I_UnCreat;
return NULL;
}

