/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2011
	Copyright Linjianghua(Xempo)
	Reserve all rights this file
*/

#include "dire.h"

bool IsUseDir(RunTimLib *lib,_Long adr)
{
 _Long padr;
 DIRE *dir, dirbuf;
 if(lib->CurDir){
   dir=lib->CurDir;
   padr=dir->pOwn;
   while(padr>0){
     if(padr==adr)return true;
     padr=dir->ptr_dir0;
     if(padr!=0)dir=DirRead(lib,&dirbuf,NULL,padr);
   }
 }
 return false;
}

DIRE *DirRead(RunTimLib *lib,DIRE *dirbuf,DirStat *du,_Long adr)
{
  if(lib->CurDir==NULL||lib->CurDir->pOwn!=adr){
    _Int rt, i;
    idxdscpt=dkread(lib,adr,&dirbuf->selfdir,du? du->savelen:rtlsze,1)<1 ? ErrScnFile:0x7fff;
    if(du)memcpy(dirbuf,du,d_statLen);
    else dkread(lib,dirbuf->OwnStat,dirbuf,d_statLen,1);
    dirbuf->n_statLen=GetLenght(getshadow(dirbuf));
    dirbuf->lib=lib;
    return dirbuf;
  }
  else return lib->CurDir;
}

int DirClose(RunTimLib *lib,DIRE *dir)
{
int rt=0;
if(dir){
  if(dir->mdf&31){
	if(dir->mdf&8) lib->mdf|=2;/* save as flg, no compress when rtlclose */
	dkwrite(lib,dir->pOwn,&dir->selfdir,dir->savelen);
  }
  free(dir);
}
return rt;
}

DIRE *DirOpen(RunTimLib *lib,DIRE *cdir,char *path_nam)
{
 static const char sepa1[]="/\\";
 DIRE *dirbuff;
 DirStat *dunit;
 char *ptr=NULL, *dirnam=NULL, *pthname=path_nam;
 RTLisNull(lib)
 idxdscpt=0x7fff;/* is flages */
 if(pthname==NULL)return cdir;
 if(fmtVal(pthname)==0){
	cdir=(DIRE *)ReGetDir(cdir,NULL,0); /* root-dir, ought to is point=SPC */
	goto _ext_;
	}
 if((*pthname=='/' ||*pthname=='\\')&&pthname[1]==0){  idxdscpt=0x7ffe; return NULL; }
/*------------------ get special path ------------------*/
dirbuff=DIRalloc();
if(*pthname=='.'&&pthname[1]=='.'){
p_dir:	if(!cdir){
		idxdscpt=I_PthInv;
		goto __ex;
	}
	if(cdir->ptr_dir0==0){
		cdir=NULL;
		goto _jmp_;
		}
	cdir=DirRead(lib,dirbuff,NULL,cdir->ptr_dir0);
_jmp_:	switch((++pthname)[1]){
	case '.' :  goto p_dir;
	case '/' :
	case '\\' : pthname++;
	case 0 : pthname++; break;
	default : idxdscpt=I_PthInv; return NULL;
	}
}
else if(*pthname=='.')switch( pthname[1] ){
		case '/' :
		case '\\': pthname++; /* self-own */
		case 0 : pthname++;
		}
/* --- make extend function ---- get special path end ----------------- */
 if(*pthname==0)goto __ex;
 dirnam=strdup(pthname);
 pthname=strchrs(dirnam,sepa1);

 if(pthname&&pthname==dirnam){
	cdir=NULL;    pthname++;
	}
 else pthname=dirnam;
 do {
   if((ptr=strchrs(pthname,sepa1))!=NULL)*ptr++=0;
   if((dunit=DirSeek(lib,cdir,pthname,DIRE_READ))!=NULL)
	cdir=DirRead(lib,dirbuff,dunit,dunit->pDir);
   else {
	idxdscpt=ptr? I_PthInv:I_NoDir;
	cdir=NULL;	   break;
   }
 }while((pthname=ptr)!=NULL);
 if(dirnam)free(dirnam);
__ex: if(cdir!=dirbuff)free(dirbuff);
_ext_: return cdir;
}

void *ReGetDir(DIRE *dir,DIRE *lmt,int IsChs)
{
char *pth, *ptr;
_Long adr;
DIRE *dirbuf, *dir1;
RunTimLib *lib;
 if(dir==NULL)return NULL;
 lib=dir->lib;
 if((adr=dir->ptr_dir0)<1){
	switch(IsChs){
	case 0 : return dir;
	case 1 : return catstr(NULL,dir->name,ROOT_CH);
	}
  return strdup(dir->name);
  }
 pth=strdup(dir->name);
 dirbuf=DIRalloc();
 do{
   dir1=DirRead(lib,dirbuf,NULL,adr);
   if(IsChs){
     if(lmt&&lmt->pOwn==adr)goto out;
     ptr=pth; pth=catstr(dir1->name,pth, ROOT_CH);
     free(ptr);
   }
  adr=dir1->ptr_dir0;
 }while( adr>0 );
out: if(IsChs||dir1!=dirbuf)free(dirbuf);
 if(IsChs){
   if(adr<1&&IsChs==1){
	ptr=catstr(NULL, pth, ROOT_CH);
	free(pth);
	return ptr;
	}
   return pth;
 }
return dir1;
}
