/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010
  Copyright Xempo
  reserve all rights of this file
*/

#include "dlist.h"

#ifndef  _STDIO_H
#include <bios.h>
#endif

int ScrLk, pagemore;

void PageMore(void)
{
if(pagemore){
  if(ScrLk++>21){
	printf("--- more ---"); ScrLk=0;
#ifdef	_STDIO_H
{
	char bu[8];
	fgets(bu,7,stdin);
}
#else
	_bios_keybrd(0);
#endif
	puts(SPC);
	}
}
}

void ShowStat(DirShadow *pdp, BYTE *pStat)
{
_Long nmb=isZero(pdp->Format) ? pdp->_numb_++ : *(_Long *)(pStat+statNumPos);
if(*pStat==1){
	_Long Len=0;
	un_Int len, tlen, j;
	for(j=0;j<pdp->_DAU;j++){
		GetLenDAU(pdp,pStat,&len,&tlen,j);
		Len+=len;
		}
#ifdef _STDIO_H
	printf("%d\t\t %d\n", nmb, Len);
#else
	printf("%ld\t\t %ld\n", nmb, Len);
#endif
	PageMore();
	}
}

int n_list(RunTimLib *lib,DIRE *dir,BYTE *pStat)
{
  DirShadow *pdp=GetDirShadow(dir,lib);
  int i=pdp->num_stats_block;
  while( i-- > 0 ){
	ShowStat(pdp,pStat);
	pStat += pdp->n_statLen;
	}
  return 1;
}

int d_list(RunTimLib *lib,DIRE *pcdir,DIRE *dir)
{
  char *pt=(char *)ReGetDir(dir,NULL, 2);
  int i;
  for(i=0; i<loop_depth; i++)
	printf("  ");
  printf("> %s %c [numb:%ld] ",pt, isZero(dir->Format) ? 'Z' : 32, dir->selfnumb);
  free(pt);
  printf("[dir:%ld]  [sz=%ld]\n",dir->selfdir,dir->sz);
  PageMore();
  return 1;
}

void List(RunTimLib *lib, int n, char **pm, int nCom)
{
  DIRE *dir;
/*  char *pt;*/
  if(IsNumber(*pm)){
    _Long numb;
    DirShadow *pdp;
    BYTE *stat;
    dir=DirOpen(lib,lib->CurDir,PathFixNumb(*pm,&numb));
    if(idxdscpt<0x7ffd){ reportBug(); return; }
    pdp=GetDirShadow(dir,lib);
    switch(nCom){
    case -309 :
    case -300 : 
	if((stat=StatSeek(lib,dir,numb,NULL,NUMB_BROW))!=NULL){
	  ShowStat(pdp,stat);
	  free(stat);
	}
	else reportBug();
	break;
    }/* sw */
  }
  else {
    int  msg;
    loop_depth=0;
    dir=JxDirPara(lib,n,pm,NULL,&msg,nCom);
    if(idxdscpt>0x7ffd){
        switch(nCom){
	case -300 : if( (msg&3)==0 )msg|=1;
	case -309 :
		CDirInfo(lib,dir,InpBuf);
		puts(InpBuf);
		DirFullBrow(lib,nCom==-309? 7:msg,n_list,dir,d_list);
	}/* sw */
    if(dir!=lib->CurDir)DirClose(lib,dir);
    }
    else reportBug();
  }
}

void CDirInfo(RunTimLib *send,DIRE *dir,char *buff)
{
DirShadow *pdp=GetDirShadow(dir,send);
sprintf(buff,"%s %c  numb:%ld  dir:%ld  sz=%ld", dir? dir->name : rootchs,
    isZero(pdp->Format) ? 'Z' : 32, pdp->selfnumb,pdp->selfdir,pdp->sz);
}

