/*
  Designed by Linjianghua(Xempo) 2004-2006
  Copyright Linjianghua
  reserve all rights
*/
#include "numbio.h"
#include "jxswitch.h"

const char TypeChr[]="cilbwdCILnovtyf",
/* 0-8 _Int; must do CASE
9 None( no write any to DAU )
10 disk-addr(Pointer);
11 0ִmǷָ0ȡ
12 'v' no-cvt-data(void type);
13 't' normal-strings(Text), cvt "\r\n"=>"\n";
14 'y' like 't', but free input, cut 2 side CHAR(13,10,32,9), only use Sold
15 file(load one file into);
*/

brow_chr[]="nditep"; /* e => exclude self-dir */

const int brow_int[]={1,2,4,7,8, 512/*page*/};

bool isNumb(const char *pt)
{
  char ch;
  while((ch=*pt)=='-'||ch=='+'|| ch>('0'-1)&&ch<('9'+1) )pt++;
  return(ch==9||(ch|32)==32);
}

bool IsNumber(char *pth)
{
if(pth){
  char  *pt=rstrrchr(pth,'\\',ROOT_CH);
  if(*pt==0)return false; /* is "\\" */
  return isNumb(pt);
}
else return false;
}

bool numNone;
char *PathFixNumb(char *pth,_Long *nmb)
{/* main get nmb value */
numNone=true;
if(pth){
  char *pnmb=(char *)separChr(pth);
  if(pnmb){
      if(isNumb(pnmb+1)){
	*nmb=atol(pnmb+1);
	if(pnmb==pth)pnmb++;
	*pnmb=0;
	numNone=false;
	}
      return pth;
  }
  else {
      if(isNumb(pth)){
	numNone=false;
	*nmb=atol(pth);
	}
   }
}
return NULL;
}

int SortPara(int n,char **lst,int *cnt)
{/* format: name -x -xxx */
  int i, browpos, j=0;
  char **pm=(char **)malloc(n*4 + 4/* safe */);
  for(i=0;i<n;i++)if(*lst[i]!='-')pm[j++]=lst[i];
  browpos=j;
  for(i=0;i<n;i++)if(*lst[i]=='-'&&lst[i][2]==0)pm[j++]=lst[i];
/* brow para sort */
  *cnt=j-browpos; /* how many -x to count */
  for(i=0;i<n;i++)
	if(*lst[i]=='-'&&lst[i][1]!=0&&lst[i][2]!=0)pm[j++]=lst[i];
  for(i=0;i<n;i++)lst[i]=pm[i];
  free(pm);
  return browpos;
}

void ErrInfo(int idx,const char *txt)
{
int y,	x=strlen(txt);
#ifdef	_STDIO_H
y=-1;
#else
cursorXY(NULL, &y);
#endif
PrnTxt(1,y,x,10,txt); 

#ifndef	_STDIO_H
gotoXY(x+2,y);
#else
printf("\033[2C");
#endif

ManuInfo(idx,1);
}

int cvtparas(int cnt,char **lst,const char *pmfmts,const int *pmval)
{
int val=0, i, j, b, flg=0;
char ch;
for(i=0;i<cnt;i++)
  for(b=1;lst[i][b];b++){
/*    printf("ini: %c\n",lst[i][b]);*/
    for(j=0;(ch=pmfmts[j])!=0;j++)
	if(lst[i][b]==ch || (ch|32)>'a'-1 && (ch|32)<'z'+1 && (lst[i][b]^ch)==32 ){
/*	printf("%c=%c\n",lst[i][b],pmchrs[j]);*/
		val|=pmval[j]; break;
		}
   if(ch==0){ flg=1; ErrInfo(43,lst[i]); }
  }
return flg? -1:val;
}

static char errParas[2];
int CvtPara(char *pm,const char *fmt)
{
  int val=0, i, j, flg=0;
  char ch;
  for(i=0;((ch=pm[i])|32)!=32;i++){
     if(ch=='-')continue;
     for(j=0;fmt[j];j++)
	if(ch==fmt[j]||(ch|32)==fmt[j]){
		val|=1<<j; break;
		}
	if(fmt[j]==0){ flg=1; *errParas=ch; ErrInfo(44,errParas); }
	}
  return flg? -1:val;
}

const un_Int prepara[4]={  0, 10, 4, 1 };
char *FixDirPara(int n,char **lst, un_Int *para)
{/* DIRE para */
  int i, tmp;
  char *pm, *dirnam=NULL;
  static const int rtl_int[]={ 1, 16384 };
  memcpy(para, prepara, sizeof(prepara) );
  for(i=0;i<n&&(pm=lst[i])!=NULL;i++)if(*pm=='-'){
      switch(pm[2]){
      case 0 :
	if((tmp=cvtparas(1,lst+i,"ZF",rtl_int))!=-1)*para=tmp;
/*	if(val<0)errpms: else style|=val;*/
	break;
      case ':' :
	switch(pm[1]|32){
	case 'n' :
	case 'd' : para[(pm[1]|32)!='d'? 1:2]=atoi(pm+3); break;
	case 'u' : para[3]=atoi(pm+3); break;
	default : _err: ErrInfo(43,pm);
	}
	break;
      default : goto _err;
      }
   }
   else if(dirnam==NULL)dirnam=pm;
  return dirnam;
}

char ErrorPara;
int setType(BYTE *idx, int n,int cnt, char ch, char extpara)
{
int t;
for(t=0;t<Type_Count;t++)/* Type_Count+1 */
    if(ch==TypeChr[t]||(ch|32)==TypeChr[t]&&t>IntType_Count-1)break;
if(t<Type_Count){
	idx[n]=t;
	if(t==_separa)idx[cnt+n]=extpara;
	}
else {
	ErrorPara=ch;	DefaultManu(39);
	}
return t;
}

void ComExtParas(char *extpara,BYTE *idx,int cnt,BYTE defau)
{/* TYPE & MODE in command ext-para, it must adjust all error,
so can't div func */
if(idx){
    memset(idx,defau,cnt);
    if(extpara){
      char ch;
      int i, t=0, n=0;
      for(i=0;i<47&&(ch=extpara[i])!=32&&ch;i++)
	if(t!=_separa&&ch!='.'&&(ch<48||ch>57))
		t=setType(idx,n++,cnt,ch,extpara[i+1]);
	}
    }
}

DIRE *JxDirPara(RunTimLib *lib,int n,char **pm, const char **mfmt,int *msg,int nCom)
{/* return dir, if n==0 return current */
char *ptr;
int val=0, cnt, i, j, t=0, m, pos=SortPara(n,pm,&cnt);
pagemore=0;
 if(pos<n){
    ptr=pos? *pm:NULL;
    m=pos+cnt;	i=n-m;
    while(t<i){
	   if(mfmt){
		for(j=0;mfmt[j];j++)
		  if(strcmp(pm[m+t],mfmt[j])==0){
			val|=1024<<j; goto skp;
			}
		ErrInfo( 43 , pm[m+t]);
		}
       skp:t++;
     }
    *msg=val;
    if(cnt){
	val=cvtparas(cnt,pm+pos,brow_chr,brow_int);
	if(val>0){ 
	   if(val!=512)*msg|=val;
	   pagemore=val&512;
		}
	else { UsageMsg(nCom); return NULL; }
	}
  }
 else { ptr=*pm;	*msg=0;	}
 return DirOpen(lib,lib->CurDir,ptr);
}
