/*
	Write & edit by Linjianghua(Xempo) 2004-2006,2008-2011
	Copyright Linjianghua(Xempo)
	Reserve all rights this file
*/
#include "rtlproj.h"
#include "dire.h"

FILE *mainfp, *rtlout;

union Cvt {
_Long lVar;
_Int iVar;
char ch;
};

union uCvt {
unsigned _Long lVar;
un_Int iVar;
BYTE ch;
};

void OutCvt(MAU *send,int t)
{/* text void is same effect in read, is defferecnt of input(free write) */
char *pt=send->buf, *buf;
if(t<IntType_Count &&pt){
  union Cvt  cvt;
  union uCvt *pUcvt=(union uCvt *)&cvt;
  int j, len=0,
	s=intType[t],
	intcnt=send->len/s;

	buf=(char *)malloc(send->len * 5 + 8/* safe */);/* 8bit alloc 4char */
	for(j=0;j<intcnt;j++,pt+=s){
		memcpy(&cvt, pt, s);
		len+=sprintf(buf+len,CvtFmt[t], t>2 && t<6? (s>1? (s>2? pUcvt->lVar : pUcvt->iVar) : pUcvt->ch) : 
		(s>1? (s>2? cvt.lVar : cvt.iVar) : cvt.ch) );
		}
	free(send->buf);
	send->len=--len;  /* -1 is del end(,) */
	buf[len]=0;
	send->buf=buf;
	}

}

void showMAU(FILE *fp,MAU *pdat, _Int type, bool msg)
{
if(pdat->buf){
  static const char hdtag[]=" .";
  OutCvt(pdat,type);
  if(msg){
    if(fp==stdout){
#ifdef	_STDIO_H
	printf("\033[34m%s\033[0m", hdtag);
#else
	int y;
	cursorXY(NULL, &y);
	printf(hdtag);
	*(char far *)(dosVM+160*(y-1)+2+1)=1;
#endif
	}
    else fwrite(hdtag,2,1,fp);
     }
/*    fwrite(pdat->buf,pdat->len,1,fp);
    fwrite(EnterWrap,2,1,fp);*/
    fprintf(fp, "%s\n", pdat->buf);
    if(out_scrn_same)puts(pdat->buf);
    free(pdat->buf);
}
}

bool Select(RunTimLib *lib,char *pm,char *extpara,int nCom, int msg)
{
 MAU *mau;
 static char putchr[]="\nDisplay %s\\%ld\n";
 _Long numb;
 _Int n, j, i, len;
 BYTE  *stat=NULL;
 FILE *fp;
 DIRE *dir;
 char  *ptr, *pt=PathFixNumb(pm,&numb);
 if(numNone){ ManuInfo(42,1); return false; }
 dir=DirOpen(lib,lib->CurDir,pt);

 if(idxdscpt>0x7ffd){
   DirShadow *pdp=GetDirShadow(dir,lib);
   if(nCom==1040||nCom==-348){
	fp=mainfp&&extpara==NULL? mainfp:fopen(extpara? "display.txt":"RTL.log",extpara? "a":"w");
	ptr=ftell(fp)!=0? putchr:putchr+1;
	pt=(char *)ReGetDir(dir,NULL,true);
	fprintf(fp,ptr,pt?pt:SPC,numb);
	if(out_scrn_same)printf(ptr,pt?pt:SPC,numb);
	if(pt)free(pt);
	}
   else fp=stdout;/* stdout define as &_stream[1],
	when define as _stream+1, size no change */
     rtlout=fp;	n=pdp->_DAU;
     mau=MAUalloc(n);
     if((stat=NumbRead(lib,dir,numb,mau,n, msg))!=NULL){
	BYTE *_type=NULL;
	if(extpara&&*extpara){
		_type=(BYTE *)malloc(n);
		ComExtParas(extpara,_type,n,_void/* '-' */);
		}
	for(j=0;j<n;j++)
		showMAU(fp,mau+j, _type ? _type[j]:_void, n>1);
	if(nCom==1040)fprintf(fp,"\n");
	if(extpara&&*extpara)free(_type);
	free(stat);	/* no show anything for SPE read */
	}
    else reportBug();
    free(mau);
    rtlout=stdout;
    if(nCom==1040||nCom==-348){
	if(extpara||stat==NULL)fclose(fp);
	else mainfp=fp;
	}

   if(dir&&dir!=lib->CurDir)free(dir);
 }
 else reportBug();
return stat!=NULL;
}
