/*
  Designed by LinJiangHua(xempo) 2004-2005
  Copyright 2004-2005 Linjianghua(xempo).
  All Rights Reserve.
*/

#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dos.def"
#include "rtlproj.h"
#include "jxswitch.h"
#include "rtlcom.h"
#include "normlib.h"

static char *mblk;
static unsigned int xdf, selflg, blksta, blkend, blklen;

void gotoXY(int x, int y)
{
union REGS regs;
regs.h.ah = 2; /* set cursor postion */
regs.h.dh = y-1;
regs.h.dl = x-1;
regs.h.bh = 0; /* video page 0 */
int86(0x10, &regs, &regs);
}

void cursorXY(int *x, int *y)
{
union REGS rg;
rg.h.ah=0x3;
rg.h.bh = 0; /* video page 0 */
int86(0x10,&rg,&rg);
if(x)*x=rg.h.dl+1;
if(y)*y=rg.h.dh+1;
}

void cursorRec(int hBegin,int hEnd)
{/* hBegin=0 or 8; hEnd=1,2,3 */
union REGS rg;
rg.h.ah=0x1;
rg.h.ch=hBegin;	rg.h.cl=hEnd;
int86(0x10,&rg,&rg);
/*CSR0=b;	CSR1=e;*/
}

void clear()
{
int i;
#define frontColor  7
#define blackColor  0
int far *vm=(int far *)dosVM;
for(i=0; i<80*24; i++)
	vm[i]=0|((frontColor|(blackColor<<4))<<8);
gotoXY(1,1);
}

void PrnTxt(int x,int y,int wdth,unsigned char attr,const char *txt)
{
char far *prn=(char far *)(dosVM+(y-1)*160+x*2);
unsigned char rattr=attr>>4|attr<<4;
unsigned int s, n, blk1, blk2;
bool flg = txt!=NULL;
if(blksta<blkend){ blk1=blksta; blk2=blkend; }
else { blk2=blksta; blk1=blkend; }
for(s=0,n=xdf;s<wdth;s++,n++){
	if(txt[n]&&flg)prn[s*2]=txt[n];
	else { flg=0; prn[s*2]=0; }
	prn[s*2+1]=selflg&&n>=blk1&&n<blk2? rattr:attr;
	}
}

static int Procblk(char *pt,int key)
{
unsigned int blk1, blk2;
if(blksta<blkend){ blk1=blksta; blk2=blkend; }
else { blk2=blksta; blk1=blkend; }
blklen=blk2-blk1;
if(key==ALT_W||key==CTRL_X){
	if(mblk)free(mblk);
	mblk=(char *)malloc(4+blklen);
	memcpy(mblk,pt+blk1,blklen);
	mblk[blklen]=0;
	}
if(key!=ALT_W){
	Delete(pt+blk1,blklen);
	selflg=false;
	}
return blk1;
}

static bool GetSelTxt(int KBSTAT,unsigned int idx)
{
bool flg=0;
if(KBSTAT&3){ /* test 0,1 bit */
  if(selflg){ blkend=idx;  flg=2; }
  else {  blksta=idx; selflg=true; flg=1; }
	}
else if(selflg){ selflg=false; flg=2; }
return flg;
}

/*void SaveCmLst(ComLst *comlst,char *buf)
{
if(comlst){
    int n=strlen(buf), i=0;
    while(comlst->BufLen+n-i>COMLST_BUFF){
	while(comlst->ComBuf[i])i++;
	comlst->BufCn--;	i++;
	}
    if(i>0){
	comlst->BufLen-=i;
	memmove(comlst->ComBuf,comlst->ComBuf+i,comlst->BufLen+1);
	}
    scopy(comlst->ComBuf+comlst->BufLen,buf);
    comlst->BufLen+=n+1; comlst->BufCn++;
	}
}*/

int InpText(char *pt, const _Int *kmsg, ComLst *comlst)
{
#define KGotoxy(pm) gotoXY(pm+1,Y)
static const int togSeltxt[5]={LEFT,RIGHT,HOME,END, 0};
int X, Y, width, cx=0, i,SelStat, KBSTAT, key=0, BufIdx;
unsigned int idx=0, szline=0, cn, t;
char far *prn;
char attr, ch=0;
fflush(stdout);
cursorXY(&X, &Y);
width=80-X--;
prn=(char far *)(dosVM+(Y-1)*160+X*2);
attr=prn[1];
xdf=0;
BufIdx=comlst->BufCn;
PrnTxt(X,Y,width,7<<4|1,pt);
cn=strlen(pt);
while(! isdone(key,kmsg)){
if(ch){/* unsuppose normal TAB  display here, mem use too more */
	if(selflg){idx=Procblk(pt,key);
		cn-=blklen;	cx=idx-xdf;
		if(xdf>idx){ xdf=idx; cx=0; }
		}
	memmove(pt+idx+1,pt+idx,szline+1);
	pt[idx++]=ch;	pt[++cn]=0;	ch=0;
	if(cx+1<width)KGotoxy(++cx+X);
	else xdf++;
	PrnTxt(X,Y,width,7<<4|1,pt);
	}
KBSTAT=_bios_keybrd(2);
if((key=_bios_keybrd(1))!=0){
	_bios_keybrd(0);	szline=cn-idx;
	if(isdone(key,togSeltxt))SelStat=GetSelTxt(KBSTAT,idx);
/*--------------------------------------------------------*/
switch(key){
case RIGHT :
	if(idx<cn){
		if(cx+1<width)KGotoxy(++cx+X);
		else {  xdf++;	PrnTxt(X,Y,width,7<<4|1,pt); }
		idx++;
		}
	break;
case LEFT :if(idx>0){
left: 		if(cx<1){ xdf--;
			PrnTxt(X,Y,width,7<<4|1,pt);
			}
		else KGotoxy(--cx+X);
		idx--;
		if(key!=BKSP)break;
	   }
	   else break;
case DEL : 
	if(selflg)goto procsel;
	if(idx<cn){
		Delete(pt+idx,1);
		PrnTxt(X,Y,width,7<<4|1,pt);
		cn--;
	}
	break;

case HOME : if(xdf>0){ xdf=0; PrnTxt(X,Y,width,7<<4|1,pt); }
		cx=0;	idx=0;	
		KGotoxy(X+cx);
		break;
case END : if(cn>width){ xdf=cn-(width-1); cx=width-1;
		PrnTxt(X,Y,width,7<<4|1,pt);
		}
	   else cx=cn;
	idx=cn;	KGotoxy(X+cx);
	break;
case BKSP : /*if(selflg)goto procsel;*/
	bksp:if(idx>0)goto left;
		break;
case UP : if(comlst&&BufIdx>0){	BufIdx--; goto f3; }
		break;
case DOWN : if(comlst&&BufIdx<comlst->BufCn)
		if(++BufIdx==comlst->BufCn){
			*pt=0;	goto show;
			}
		else goto f3;
		break;
case F3 :
	if(comlst&&comlst->BufCn>0){
	BufIdx=comlst->BufCn-1;
	f3:for(i=0,t=0;i<comlst->BufLen&&t<BufIdx;i++)
		   if(comlst->ComBuf[i]==0)t++;
	scopy(pt,comlst->ComBuf+i);
	show:selflg=false;
	PrnTxt(X,Y,width,7<<4|1,pt);	cn=strlen(pt);
	cx=cn;	szline=0;	idx=cn;
	KGotoxy(X+cn);
	}
	break;
case ALT_W  : 
case CTRL_X : if(selflg){
		procsel:idx=Procblk(pt,key);
		if(key==ALT_W)break;
		cn-=blklen;
		if(xdf>idx){ xdf=idx;idx=0; }
		cx=idx;	KGotoxy(cx+X);
		PrnTxt(X,Y,width,7<<4|1,pt);
		if(key==BKSP)goto bksp;
		}
	break;
case CTRL_V : if(mblk){
		if(selflg){ idx=Procblk(pt,key); cn-=blklen; }
		Insert(pt+idx,mblk);
		t=strlen(mblk);
		cn+=t; idx+=t;
		cx=idx-xdf;	selflg=false;
		if(xdf>idx){ xdf=idx; cx=0; }
		else if(cx>=width){ xdf+=cx-width+1; cx=width-1; }
		PrnTxt(X,Y,width,7<<4|1,pt);
		KGotoxy(X+cx);
		}
		break;
default : ch=key&0xff;
}
if(isdone(key,togSeltxt)){
	GetSelTxt(KBSTAT,idx);
	if(SelStat)PrnTxt(X,Y,width,7<<4|1,pt);
	}
   }
}
for(cn=0;cn<width;cn++)prn[cn*2+1]=attr;
puts(SPC);	selflg=false;
if(comlst&&*pt){
    cn=strlen(pt);    i=0;
    while(comlst->BufLen+cn-i>COMLST_BUFF){
	while(comlst->ComBuf[i])i++;
	comlst->BufCn--;	i++;
	}
    if(i>0){
	comlst->BufLen-=i;
	memmove(comlst->ComBuf,comlst->ComBuf+i,comlst->BufLen+1);
	}
    scopy(comlst->ComBuf+comlst->BufLen,pt);
    comlst->BufLen+=cn+1; comlst->BufCn++;
}
return key;
#undef KGotoxy
}
