/*
	Write & edit by Linjianghua(xempo) 2005-06,2008-2012
	Copyright Linjianghua(xempo)
	reserve all rights of this file
*/

#ifndef _RUN_TIME_LIB_
#define _RUN_TIME_LIB_

#define OverLay_Numb	108

#include <time.h>
#include <sys/stat.h>

#include "dos.def"
#include "infodef.h"
#include "datastru.h"

/* dir Style (Format) */
#define ZeroMode		1
#define isZero(style)		(style&ZeroMode)

/* because 128 beyound all values, perhan numbstat's mode no exist, let it be 128 */
#define LimitVal(n)		(n<1? 8:n)

#define PageBufSiz		8
#define PgBufDivLen		9
#define _PgBufSiz		7

#ifdef _STDIO_H
#define SPACELIMIT		30
#define LASTSPACE		29
#else
#define SPACELIMIT		13
#define LASTSPACE		12
#endif

#define sybchrlen		24
#define libtaglen		13

#define CTRL_Q		4113

#define NUMB_DEL	        256
#define NUMB_REN	        258
#define NUMB_WRITE	        260
#define NUMB_READ	        264
#define NUMB_RESCUE 	        272
#define NUMB_STAT_POS           289
#define NUMB_LAST		290
#define NUMB_STAT_BLANK		320
#define NUMB_BROW               384
#define	NUMB_SYS_ID		16384
#define	FREE_READ		8192

#define DIRE_DEL                512
#define DIRE_REN		514
#define DIRE_WRITE	        516
#define DIRE_READ	        520
#define DIRE_RESCUE 	        528
#define DIRE_STAT_POS		545
#define DIRE_STAT_BLANK		576
#define DIRE_BROW		512+128

#define RTL_DEL			0
#define RTL_REN			2
#define RTL_WRITE		4
#define RTL_READ		8
#define RTL_RESCUE		16
#define	RTL_STAT_POS		33
#define RTL_STAT_BLANK		64
#define RTL_BROW		128

#define DIRE_ERASE	8007

#ifndef _K_RUNTIME_
#define COMLST_SIZE	400
#define COMLST_BUFF	395
typedef struct {
_Int BufLen, BufCn;
char ComBuf[396];
}ComLst;
#endif

typedef struct {
_Long _numb_, /* the CSB first numb */
pDIRE, pCSB;
}zdivPage;

typedef struct {
char *buf;
unsigned _Int len;
}MAU;

typedef struct {
un_Int mlen, len;
_Long addr;
}DAU;

/*   numb stat format, like dir stat DirStat struct
flag 1     0:init, 1:use, 2:del
numb 4
----------------
type[DAU]
*/

#define	statNumPos	1
#define statDAUPos(style) (isZero(style) ? statNumPos : statNumPos+4)	

typedef struct {
  unsigned char Flags; /* 0:init, 1:use, 2:del */
#define namepos         1
#define DirNamLen       21
#define Dirnamelen	20
char  name[DirNamLen];
un_Int savelen;
#define DIRE_ADDR	24
_Long pDir;
}DirStat; /* sizeof(...)=28, don't use BYTE for name */
#define d_statLen	sizeof(DirStat)

typedef  struct  _RTL  RunTimLib;

/* follow use to DIRE */

typedef struct {
_Long  nx_CSB,		/* next_csb, save for libfnd */
  cur_CSB;         /* current style address */
unsigned char cnt_unit, /* alloc dir-stat every CSB(Disk-Space-Blank) */
  Flag;		/* use for stat flg */
}CSB_Unit;

typedef struct {
/* ----------- DirStat struct ----------- */
  BYTE Flags;
  char name[DirNamLen];
  un_Int savelen;
  _Long pOwn;            /* ptr(dsk) this black */
 /* ------------ image DirStat end ------------- */

  BYTE mdf, n_statLen;
  _Int compact;

  _Long c_CSB_numb, /* use story addr, so that save CSB */
  _numb_;
/* disk save begin */ 
  _Long selfdir,
  selfnumb,	        /* total count of Numb */
/* -------- numb CSB_Unit ---------- */
  n_CSB_numb,         /* current CSB of numb */
  CSB_numb;		   /* this dir's numb-style address */
  unsigned char num_stats_block,		/* alloc stats every CSB */
  dIdx;
/* ----- end CSB ----- */
  un_Int Format;/* idx lenght-style, its numb-style,  Z  */

/*  dir CSB_Unit  */
  _Long n_CSB_dir,		/* next_csb, save for libfnd */
  CSB_dir;         /* this dir's dir-style address */
  BYTE  dir_stats_block, /* alloc dir-stat every CSB(Disk-Space-Blank) */
  dir_compact;		/* no use, compact */
/* -------- end CSB --------- */
  un_Int _DAU; /* can be 7256 dau, as 7256*9+31=65335, in fact 7200 */

_Long  sz, ptr_dir0,
  OwnStat;		/* ptr(dsk) this dir's stat */
/*--------- end disk-storage ! DON'T change pos ----------- */
#define rtlsze	44
 RunTimLib *lib;
}DIRE;

struct _RTL {
  char *fname;
  FILE *fpt;
  BYTE mdf,/* 1:flash;  8:del, talk about, 64:SPEC dir in useing */
  n_statLen,
  fd, msg_OL; /* write numb is existed flag */

  _Long c_CSB_numb,/* use story addr, so that flash CSB */
	_numb_;

/* disk begin */
  _Long selfdir, selfnumb,
/* ------numb CSB_Unit ------- */
  n_CSB_numb,  pCSB_numb;
  BYTE num_stats_block, dIdx;
/* -------- end CSB -------- */
  un_Int Format;

/* ----- dir CSB_Unit -------*/
  _Long DefaultDir, pCSB_dir;
  BYTE dir_stats_block,
	dir_compact;
/* -------- end CSB ------- */
  un_Int _DAU;

  _Long usesize,

  tolNumb,  tolDir;

/* ----- sys numb CSB_Unit, NUMB_SYS_ID  ----- */
  _Long sys_CSB_numb,  sys_pCSB_numb;
  BYTE sys_num_stats_block, sys_dIdx;
/* -------- end CSB -------- */

  unsigned _Int bufsiz;
  BYTE CmprPer, CmprSiz;

#define ctrlsize		62
#define FS_FMT		6
  char  fsfmt[FS_FMT];
  DIRE *CurDir;
  _Long fsz,  statpos,
  LNKDWORD, CSB_calc;

#ifndef		_STDIO_H
  ComLst *comlst;   /* doscon */
#endif

  zdivPage zdpbuf[PageBufSiz];/* 2 type buffer, one is div, one is rec */
  int pg_use;
};

/*-------- self rtl --------*/
#define PATH_STREAM		2
#define CONFIG_STREAM		3
#define AUTORUN_STREAM		4
/* normal only 0,1 as spec */

typedef struct {
  BYTE mdf, n_statLen;
  _Int compact;

  _Long c_CSB_numb, /* use story addr, so that save CSB */
  _numb_;
/* disk save begin */
  _Long selfdir,
  selfnumb,	        /* total count of Numb */

/* ====== numb CSB ====== */
  n_CSB_numb,         /* next CSB of numb */
  CSB_numb;		   /* this dir's numb-style address */
  unsigned char num_stats_block,		/* alloc stats every CSB */
  dIdx;
/* ====== numb CSB end ======= */
  un_Int Format;	/* idx lenght-style */

/* ------------------------dir CSB_Unit ---------------------------*/
  _Long n_CSB_dir,		/* next_csb, save for libfnd */
  CSB_dir;         /* this dir's dir-style address */
  BYTE  dir_stats_block, /* alloc dir-stat every CSB(Disk-Space-Blank) */
  dir_compact;		/* no use */
/* ======== dir CSB end =========== */
  un_Int _DAU;

  _Long  sz;
}DirShadow;

#define RTLisNull(lib) \
	if(lib==NULL){ idxdscpt=I_NoBuff; return NULL; }

#define dGetCSB_U(dir,lib) (CSB_Unit *)(dir? &dir->n_CSB_dir:&lib->DefaultDir)
#define dgetcsb_u(pdp) (CSB_Unit *)&pdp->n_CSB_dir
#define nGetCSB_U(dir,lib) (CSB_Unit *)(dir? &dir->n_CSB_numb: &lib->n_CSB_numb)
#define ngetcsb_u(pdp) (CSB_Unit *)&pdp->n_CSB_numb
#define sys_ngetcsb_u(rtl) (CSB_Unit *)&rtl->sys_CSB_numb

#define GetDirShadow(dir,lib) ((DirShadow *)(dir? &dir->mdf:&lib->mdf))
#define getshadow(dir) ((DirShadow *)&dir->mdf)
#define GetDirStyle(dir,lib) (dir? dir->Format:lib->Format)

#define DirSeek(lib,dir,dirnam,flg) (DirStat *)StatSeek(lib,dir,0,dirnam,flg)
#define NumbSeek(lib,dir,nmb,flg) StatSeek(lib,dir,nmb,NULL,flg)
#define StatDAU(pdp,buff, iDau) \
	(buff+(pdp->n_statLen - sizeof(DAU) *(iDau+1)) )
/* DAU ==> Disk Alloc Unit */

/*------------------- RunTimLib file format ---------------------
FileFmt(Symbol-Len)
Index fType(char 1bit)
Ctrl-blank(CtrlSize[Index fType])
-------------------------format ---------------------------------

--- numb format |  '!' is persimsed user to ignore ---
flag( useful flags )
numb( ! can be _Int or _Long )
stor_unit0( adr,  len, tlen; can be BYTE or UINT )
stor_unit1( ! )
--------------- numb format -----------------*/

extern const char SPC[],FileFmt[], rootchr[],
libCode[], ExtRTL[], Gsw[], TypeStr[13][6],
RTLnam[], TypeChr[], *curprgnam;
extern  char  *InpBuf, out_scrn_same,  verbuf[];
extern int ScrLk, pagemore, OverW, del_mode;
extern RunTimLib *workspace[SPACELIMIT];
#define libmanu		workspace[0]
extern _Long BrowCnt;

extern const _Int inpkmsg[];
extern int idxdscpt, loop_depth;
extern RunTimLib *LibCmpr;
extern DIRE *dst_dir;

extern int msg_memstr;
extern char *memstr(const char *sc,unsigned int ln,const char *in,unsigned int ln2,int flg);/*Case sen*/

#define  fixstatnumb(pdp, stat)  (isZero(pdp->Format) ? pdp->_numb_++ : *(_Long *)(stat+statNumPos))

extern _Long WriteLimit(RunTimLib *lib,char *dirnam,char *dat,_Long nmb,_Int cnlmt, int msg);

extern void FreeMAU(MAU *pm, int n);

extern _Int *DirParas(DirShadow *pdp);
extern DIRE *DirCreat(RunTimLib *,DIRE *dir,char *dirname, const un_Int *pms);
/* BYTE Format,BYTE mode,BYTE cntstat,BYTE cntdir); */

extern void StatLnkWord(RunTimLib *lib,DIRE *dir,_Int *cnt,_Int len);
extern void *zalloc(size_t sz);

#define DIRalloc()	(DIRE *)zalloc(sizeof(DIRE))
#define MAUalloc(cn)	(MAU *)zalloc(cn*sizeof(MAU))
#define RTLalloc()	(RunTimLib *)zalloc(sizeof(RunTimLib))

extern void ReadStat(RunTimLib *lib, DIRE *dir,BYTE *stat,MAU *send,int n);
extern char *ReadDAU(RunTimLib *,DIRE *dir,BYTE *stat, MAU *send,int sw);
/* return send->buf */

extern BYTE *NumbRead(RunTimLib *,DIRE *dir,_Long numb,MAU *send,int n, int msg);
extern BYTE  *NumbWrite(RunTimLib *lib,DIRE *dir,_Long numb,MAU *send,int n, int msg);

extern BYTE *StatSeek(RunTimLib *,DIRE *dir,_Long numb,void *dirnam,int flg);
extern void dkwrite(RunTimLib *,_Long pos,void *dat, size_t len);
extern size_t dkread(RunTimLib *lib,_Long pos,void *dat, size_t len, size_t cn);
extern int DirClose(RunTimLib *,DIRE *dir);
extern bool BrowNumbs(RunTimLib *lib,
	       int (*procnumb)(RunTimLib *,DIRE *,BYTE *),DIRE *dir);

/* extern DIRE *_DirOpen(RunTimLib *lib,DIRE *inpdir,char *pth);*/

extern DIRE *DirOpen(RunTimLib *lib,DIRE *inpdir,char *pth);

extern _Long *GetLenDAU(DirShadow *dir,BYTE *buff,un_Int *len,un_Int *tlen,int sw);

extern char *ModeParas(int mode);

#define GetLenght(pdp) (pdp->_DAU*sizeof(DAU)+statDAUPos(pdp->Format))

extern void chgsize(RunTimLib *lib,DIRE *dir,BYTE *unit,_Int step,_Int sw);

extern void WriteDAU(RunTimLib *lib,DIRE *dir, BYTE *stat, MAU *send, int sw );
/*extern void SetStatAddr(RunTimLib *,DIRE *dir, _Long pos, BYTE *stat);*/

extern void AppCSB(RunTimLib *lib,DIRE *dir, size_t len,void *lnk, size_t off);
#define AllocCSB(lib,dir,len) AppCSB(lib,dir,len,NULL,4)

extern void FixStatFlg(RunTimLib *send,DIRE *dir,int BrowFlags);
extern DIRE *DirFixNam(RunTimLib *lib,DIRE *dir0,char *pth,char **rtname);
extern void SetChgflg(RunTimLib *lib,DIRE *dir,int step,int dirflg);
extern void dSetChgflg(RunTimLib *,DIRE *dir,int step,int dirflg, int sz);
extern void ChgStat(RunTimLib *lib,DIRE *dir,BYTE *stat,_Long pos,_Int flg,_Int dirflg);
extern int putMAU(MAU *pdat,char *buf,int msg);
extern DIRE *DirRead(RunTimLib *lib,DIRE *drbuf,DirStat *du,_Long adr);
/* return CurDir or dirbufy */

/* pro_numbs or pro_dirs depend on DirFlags
DirFlags: if pro_numb null, clear 0bit.  */
extern int DirFullBrow(RunTimLib *lib,int DirFlags,
		int (*pro_numb)(RunTimLib *,DIRE *,BYTE *),DIRE *dir,
		int (*pro_dir)(RunTimLib *,DIRE *,DIRE *));

extern void CDirInfo(RunTimLib *send,DIRE *dir,char *buff);

extern BYTE *WriteInit(RunTimLib *lib,DIRE *dir,_Long numb,MAU *send,int n, int msg);

extern void WriteStat(RunTimLib *,DIRE *dir,BYTE *statbuf,MAU *send,int n);

extern RunTimLib *RTLcreat(const char *fname, const un_Int *pms);
extern RunTimLib *RTLopen(const char *fname);
extern int RTLclose(RunTimLib *,RunTimLib* (*Compr)(RunTimLib *,const char *,const char *,int) );/* return compress flag */


/*extern bool n_remove(RunTimLib *,DIRE *dir,_Long numb);*/
extern int (*popMsg)(const char *,const char *,int);

extern int SelSpace(int sel);

extern int ModeVal;

#define namecpy(dst,src)  memcpy(dst,src,Dirnamelen)
#endif
