/*
  Designed by Linjianghua(Xempo) 2004-2006
  Copyright Linjianghua
  reserve all rights
*/

#include "stat.h"

static int SW;
int del_mode;

void Erase(RunTimLib *lib,DIRE *dir,BYTE *unit)
{
un_Int len, tlen;
MAU send;
DirShadow *pdp=GetDirShadow(dir,lib);
_Int i;
for(i=0;i<pdp->_DAU;i++){
	GetLenDAU(pdp,unit,&len,&tlen,i);
	send.buf=(char *)zalloc(tlen);
	send.len=tlen;
/*	memset(send.buf,0,tlen);*/
	WriteDAU(lib,dir,unit,&send,i);
	free(send.buf);
	}
}

void n_SetDel(RunTimLib *lib,DIRE *dir,BYTE *unit,_Long pos)
{
  *unit=2;
  ChgStat(lib,dir,unit,pos,-1,8);
  if(del_mode==DIRE_ERASE)Erase(lib,dir,unit);
}

int rm_StatNumb(RunTimLib *lib,DIRE *dir,BYTE *unit)
{
    BYTE i, msg=false, *stat=unit;
    DirShadow *pdp=GetDirShadow(dir,lib);
    int cntdir=pdp->num_stats_block, unitlen=pdp->n_statLen;/* protect bit flow */
    for(i=0;i<cntdir;i++,unit+=unitlen){
      if( SW < 0 ){/* del */
	if(*unit==1)switch(del_mode){
		case DIRE_ERASE : Erase(lib,dir,unit); break;
		case N_DELS :
		case DIRE_EMPTY : *unit=2;
			n_SetDel(lib,dir,unit,pdp->c_CSB_numb+i*unitlen);
		}
	}
      else if(*unit>1){ _Int j;
		*unit=1;  msg=true;
		for(j=0;j<pdp->_DAU/*Cnt_DAU(lib?->Format)*/;j++)chgsize(lib,dir,unit,1,j);
		pdp->selfnumb++;
		pdp->mdf|=1;
		 }
    }
    if(msg)dkwrite(lib,pdp->c_CSB_numb,stat,cntdir*unitlen);
    return 1;
}

int rm_StatDir(RunTimLib *lib,DIRE *pcdir,DIRE *Dir)
{
 int flag;
 if(Dir->Flags==0)return true; /* no init, never used */
 lib->usesize+=Dir->sz*SW;
 lib->tolDir+=SW;
 lib->tolNumb+=Dir->selfnumb*SW;
 pcdir->selfdir+=SW;
 pcdir->mdf|=1;
 flag=SW>0? 1 : 2;
 dkwrite(lib,Dir->OwnStat,&flag,1);
 return 1;
}

int n_remove(RunTimLib *lib,DIRE *dir,_Long nmb)
{
  BYTE *unit=StatSeek(lib,dir,nmb,NULL,NUMB_DEL);
  if(unit){
	n_SetDel(lib,dir,unit,lib->statpos); free(unit);
	return 1;
	}
  return 0;
}

int n_rename(RunTimLib *lib,DIRE *dir,_Long oldnmb,_Long newnmb)
{
BYTE *unit;
DirShadow *pdp=GetDirShadow(dir,lib);
if(isZero(pdp->Format))idxdscpt=I_ZeroRen;
else if((unit=StatSeek(lib,dir,newnmb,NULL,NUMB_STAT_POS))!=NULL)
	{ idxdscpt=I_DupNumb; free(unit); }
    else {
      unit=StatSeek(lib,dir,oldnmb,NULL,NUMB_REN);
      if(unit){
	dkwrite(lib,lib->statpos+statNumPos,&newnmb, 4);
	free(unit);
	return 1;
    }
    else if(idxdscpt==0x7fff)idxdscpt=I_NoNumb;
  }
  return 0;
}

int DirStatChange(RunTimLib *lib,DIRE *dir,DirStat *du,BYTE flag,_Int mode,_Int nCom)
{
  _Long pos=lib->statpos;
  DIRE *deldir, *dirbuf=DIRalloc();
  int rt, n, dir_len;
  deldir=nCom!=DIRE_EMPTY&&nCom!=N_DELS? 
	DirRead(lib,dirbuf,du,du->pDir):(DIRE *)du;
  dir_len=dir? dir->savelen:rtlsze;
  if(mode>0)n=1;
  else { n=-1;    mode=-mode;  }
  del_mode=nCom;
  SW=n;
  rt=DirFullBrow(lib, nCom!=N_DELS? 7:1,rm_StatNumb,deldir,rm_StatDir);
  if(rt){
	if(nCom!=DIRE_EMPTY/* DirEmpty */&&nCom!=N_DELS){
		dSetChgflg(lib,dir,n,mode,dir_len);
		lib->usesize+=n*(deldir->sz+dir_len);
		dkwrite(lib,pos,&flag,1);
	}
	lib->tolNumb+=deldir->selfnumb*n;
/*	DirClose(lib,deldir);*/
	}
	if(deldir!=lib->CurDir)DirClose(lib,deldir);
	else free(dirbuf);
  return rt;
}

bool d_remove(RunTimLib *lib,DIRE *dir,char *dirnam,_Int nCom)
{
 bool rt=false;
 DirStat *du=nCom!=DIRE_EMPTY&&nCom!=N_DELS? 
	DirSeek(lib,dir,dirnam,DIRE_DEL):(DirStat *)dirnam;
 if(idxdscpt>0x7ffd){
   if(nCom!=DIRE_EMPTY&&nCom!=N_DELS&&IsUseDir(lib,du->pDir))idxdscpt=I_UseDir;
   else rt=DirStatChange(lib,dir,du,2,-8,nCom);
   if(du!=(DirStat *)dirnam)free(du);
 }
 return rt;
}

bool d_rename(RunTimLib *lib,DIRE *dir,char *src,char *dst)
{
  DirStat *unit;
  if(NameVerify(dst)==false)idxdscpt=I_InvName;
  else if((unit=DirSeek(lib,dir,dst,DIRE_STAT_POS))!=NULL){
	idxdscpt=I_DupNam; free(unit);
	}
            else if((unit=DirSeek(lib,dir,src,DIRE_REN))!=NULL){
	       dkwrite(lib,lib->statpos+namepos,dst,Dirnamelen);
	       if(lib->CurDir && unit->pDir==lib->CurDir->pOwn)namecpy(lib->CurDir->name,dst);
	       free(unit);
	       return true;
	}
	else if(idxdscpt>0x7ffd)idxdscpt=6;
  return false;
}

int nFixFlag(RunTimLib *lib,DIRE *dir,BYTE *xstat)
{
    BYTE i, *unit=xstat;
    DirShadow *pdp=GetDirShadow(dir,lib);
    int num_stats_block=pdp->num_stats_block,
	unitlen=pdp->n_statLen;/* protect bit flow */
    for(i=0;i<num_stats_block;i++,unit+=unitlen)
      if(*unit>2)*unit=2;
    dkwrite(lib,pdp->c_CSB_numb,xstat,num_stats_block*unitlen);
    return 1;
}

